#include <iostream>
#include <sstream>
#include <vector>
#include <stdlib.h>
#include <time.h>

using namespace std;

class Ticket
{
    string name;
    int serial_number;
    int stamp;

public:
    Ticket(string s, int n)
    {
        name=s; serial_number=n;
        stamp = rand();
    }
    bool equals(Ticket *t)
    {
        return (name==t->name) and (serial_number==t->serial_number)
                    and (stamp==t->stamp);
    }
    string to_string()
    {
        stringstream ss;
        ss<<serial_number<<"\t"<<name;
        return ss.str();
    }
};

class TicketMachine
{
    static int number;
    static vector<Ticket*> valid_tickets;
public:
    bool use_ticket(Ticket *t)
    {
        if(is_valid(t))
        {
           for(int i=0; i<valid_tickets.size(); i++)
           {
                if(t->equals(valid_tickets[i]))
                {
                    cout<<t->to_string()<<" - Hid kinoelemusi!\n";
                    valid_tickets.erase(valid_tickets.begin()+i);
                    return true;
                }
            }
        }
        else
        {
            cout<<"ALARM! Invalid ticket: "<<t->to_string()<<endl;
            return false;
        }
    }
    Ticket *buy_ticket(string s)
    {
        Ticket *t = new Ticket(s,++number);
        valid_tickets.push_back(t);
        return t;
    }
    bool is_valid(Ticket *t)
    {
        for(int i=0;i<valid_tickets.size(); i++)
        {
            if(t->equals(valid_tickets[i]))
                return true;
        }
        return false;
    }
};

// staatiliste vljade initsialiseerimine
int TicketMachine::number = 1000;
vector<Ticket*> TicketMachine::valid_tickets;

int main()
{
    srand(time(NULL));
    // Loome mned masinad:
    TicketMachine m;
    TicketMachine m2;

    // ja ostame portsu pileteid:
    Ticket *t1 = m.buy_ticket("Sherlock Holmes");
    Ticket *t2 = m2.buy_ticket ("Mission Impossible");
    Ticket *t3 = m.buy_ticket ("Sherlock Holmes");
    Ticket *t4 = m.buy_ticket ("Mission Impossible");

    cout<<t1->to_string()<<endl;
    cout<<t2->to_string()<<endl;
    cout<<t3->to_string()<<endl;
    cout<<t4->to_string()<<endl;


    // Kontrollime, et masinast ostetud piletid on kehtivad.
    // Mrgime, et teisest masinast ostetud piletid kehtivad ka esimeses masinas
    cout<<"is_valid(t1) - "<< m.is_valid(t1) <<endl; // -> true
    cout<<"is_valid(t2) - "<< m.is_valid(t2) <<endl; // -> true

    // Kasutame pileti ra:
    m.use_ticket(t1); // -> teade: "Hid filmielamusi"
    // prast mida ei tohiks see kehtiv olla:
    cout<<"Prast sisenemist is_valid(t1) - "<< m.is_valid(t1)<<endl; // -> false
    // ning kski automaat ei tohi seda enam aktsepteerida:
    m2.use_ticket(t1); // -> teade: "ALARM! Pilet ei ole kehtiv"

    // Ise joonistatud piletiga ei tohiks olla kehtiv
    Ticket *fake = new Ticket("Sherlock Holmes",1003);
    cout<<"fake->is_valid() - " << m.is_valid(fake)  <<endl; // -> false
    // ning sellega ei pse ka saali:
    m.use_ticket(fake); // -> teade: "ALARM! Pilet ei ole kehtiv"
    m.use_ticket(t3);
    return 0;
}
